org.apache.felix.scrplugin.description

## Class ComponentDescription

- java.lang.Object
- - org.apache.felix.scrplugin.description.AbstractDescription
  - - org.apache.felix.scrplugin.description.ComponentDescription

    public class ComponentDescription
    extends AbstractDescription

`ComponentDescription` is a described component. In general all fields should be set by an annocation scanner, no default values should be assumed for these fields:

- name
- configurationPolicy

These values have the following default values:

- label : null - will be handled by the scr generator
- description : null - will be handled by the scr generator
- isAbstract : false
- isInherit : true
- createDs : true
- createPid : false (deprecated)
- createMetatype : false
- enabled : null
- immediate : null
- factory : null
- isSetMetatypeFactoryPid : false
- activate : null
- deactivate : null
- modified : null
- specVersion : null
- configuraionPid : null

### Field Summary

### Fields inherited from class org.apache.felix.scrplugin.description.AbstractDescription

`annotation`

### Constructor Summary

Constructors
Constructor and Description
`ComponentDescription(ScannedAnnotation annotation)`

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`AbstractDescription` `clone()`
`String` `getActivate()`
`String` `getConfigurationPid()`
`ComponentConfigurationPolicy` `getConfigurationPolicy()`
`String` `getDeactivate()`
`String` `getDescription()`
`Boolean` `getEnabled()`
`String` `getFactory()`
`Boolean` `getImmediate()`
`String` `getLabel()`
`String` `getModified()`
`String` `getName()`
`SpecVersion` `getSpecVersion()`
`boolean` `isAbstract()`
`boolean` `isCreateDs()`
`boolean` `isCreateMetatype()`
`boolean` `isCreatePid()` Deprecated. Do not use this anymore
`boolean` `isInherit()`
`boolean` `isSetMetatypeFactoryPid()`
`void` `setAbstract(boolean isAbstract)`
`void` `setActivate(String activate)`
`void` `setConfigurationPid(String configurationPid)`
`void` `setConfigurationPolicy(ComponentConfigurationPolicy configurationPolicy)`
`void` `setCreateDs(boolean createDs)`
`void` `setCreateMetatype(boolean createMetatype)`
`void` `setCreatePid(boolean createPid)` Deprecated. Do not use this anymore
`void` `setDeactivate(String deactivate)`
`void` `setDescription(String description)`
`void` `setEnabled(Boolean enabled)`
`void` `setFactory(String factory)`
`void` `setImmediate(Boolean immediate)`
`void` `setInherit(boolean isInherit)`
`void` `setLabel(String label)`
`void` `setModified(String modified)`
`void` `setName(String name)`
`void` `setSetMetatypeFactoryPid(boolean isSetMetatypeFactoryPid)`
`void` `setSpecVersion(SpecVersion specVersion)`
`String` `toString()`

### Methods inherited from class org.apache.felix.scrplugin.description.AbstractDescription

`getAnnotation, getIdentifier, getSource, setSource`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ComponentDescription

    public ComponentDescription(ScannedAnnotation annotation)

### Method Detail

#### getName

    public String getName()

#### setName

    public void setName(String name)

#### getLabel

    public String getLabel()

#### setLabel

    public void setLabel(String label)

#### getDescription

    public String getDescription()

#### setDescription

    public void setDescription(String description)

#### getEnabled

    public Boolean getEnabled()

#### setEnabled

    public void setEnabled(Boolean enabled)

#### getImmediate

    public Boolean getImmediate()

#### setImmediate

    public void setImmediate(Boolean immediate)

#### getFactory

    public String getFactory()

#### setFactory

    public void setFactory(String factory)

#### isSetMetatypeFactoryPid

    public boolean isSetMetatypeFactoryPid()

#### setSetMetatypeFactoryPid

    public void setSetMetatypeFactoryPid(boolean isSetMetatypeFactoryPid)

#### isAbstract

    public boolean isAbstract()

#### setAbstract

    public void setAbstract(boolean isAbstract)

#### isInherit

    public boolean isInherit()

#### setInherit

    public void setInherit(boolean isInherit)

#### isCreateDs

    public boolean isCreateDs()

#### setCreateDs

    public void setCreateDs(boolean createDs)

#### isCreatePid

    @Deprecated
    public boolean isCreatePid()

Deprecated. Do not use this anymore
Deprecated - this will always return `false` as the pid property is handled by DS

Returns:
  `false`

#### setCreatePid

    @Deprecated
    public void setCreatePid(boolean createPid)

Deprecated. Do not use this anymore
This will ignore the value provided.

Parameters:
  `createPid` - Flag

#### isCreateMetatype

    public boolean isCreateMetatype()

#### setCreateMetatype

    public void setCreateMetatype(boolean createMetatype)

#### getConfigurationPolicy

    public ComponentConfigurationPolicy getConfigurationPolicy()

#### setConfigurationPolicy

    public void setConfigurationPolicy(ComponentConfigurationPolicy configurationPolicy)

#### getActivate

    public String getActivate()

#### setActivate

    public void setActivate(String activate)

#### getDeactivate

    public String getDeactivate()

#### setDeactivate

    public void setDeactivate(String deactivate)

#### getModified

    public String getModified()

#### setModified

    public void setModified(String modified)

#### getSpecVersion

    public SpecVersion getSpecVersion()

#### setSpecVersion

    public void setSpecVersion(SpecVersion specVersion)

#### getConfigurationPid

    public String getConfigurationPid()

#### setConfigurationPid

    public void setConfigurationPid(String configurationPid)

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

#### clone

    public AbstractDescription clone()

Specified by:
  `clone` in class `AbstractDescription`